// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/telemetry_content
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/environments -i Environments -t ../../../assets/templates/middleware/telemetry_content -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	pkgId "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/environments"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements environments.Environments interface instrumented with opentracing spans
type telemetryMiddleware struct {
	environments.Environments
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base environments.Environments, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		Environments:   base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Create implements environments.Environments
func (_d telemetryMiddleware) Create(ctx context.Context, env *environments.Environment) (created *environments.Environment, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "Create"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Create")
	defer _span.End()

	created, err = _d.Environments.Create(ctx, env)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, env, created, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx": ctx,
			"env": env}, map[string]interface{}{
			"created": created,
			"err":     err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return created, err
}

// Delete implements environments.Environments
func (_d telemetryMiddleware) Delete(ctx context.Context, spaceId string, id string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "Delete"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Delete")
	defer _span.End()

	err = _d.Environments.Delete(ctx, spaceId, id)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"id":      id}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Get implements environments.Environments
func (_d telemetryMiddleware) Get(ctx context.Context, spaceId string, id string) (env *environments.Environment, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Get")
	defer _span.End()

	env, err = _d.Environments.Get(ctx, spaceId, id)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"id":      id}, map[string]interface{}{
			"env": env,
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return env, err
}

// List implements environments.Environments
func (_d telemetryMiddleware) List(ctx context.Context, spaceId string) (envs []*environments.Environment, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "List"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.List")
	defer _span.End()

	envs, err = _d.Environments.List(ctx, spaceId)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId}, map[string]interface{}{
			"envs": envs,
			"err":  err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return envs, err
}

// Migrate implements environments.Environments
func (_d telemetryMiddleware) Migrate(ctx context.Context, spaceId string, id string, options ...*environments.MigrateOptions) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "Migrate"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Migrate")
	defer _span.End()

	err = _d.Environments.Migrate(ctx, spaceId, id, options...)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"id":      id,
			"options": options}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// RemoveAlias implements environments.Environments
func (_d telemetryMiddleware) RemoveAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "RemoveAlias"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.RemoveAlias")
	defer _span.End()

	err = _d.Environments.RemoveAlias(ctx, spaceId, id, alias)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"id":      id,
			"alias":   alias}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// SetAlias implements environments.Environments
func (_d telemetryMiddleware) SetAlias(ctx context.Context, spaceId string, id string, alias string) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "SetAlias"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.SetAlias")
	defer _span.End()

	err = _d.Environments.SetAlias(ctx, spaceId, id, alias)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":     ctx,
			"spaceId": spaceId,
			"id":      id,
			"alias":   alias}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}

// Update implements environments.Environments
func (_d telemetryMiddleware) Update(ctx context.Context, env *environments.Environment) (err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "Environments"),
		attribute.String("method", "Update"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "Environments.Update")
	defer _span.End()

	err = _d.Environments.Update(ctx, env)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	params := []interface{}{ctx, env, err}
	for _, p := range params {
		if p == nil {
			continue
		}
		if sg, ok := p.(spaceGetter); ok {
			spID = sg.GetSpaceID()
			if spID != "" {
				break
			}
		}
	}
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx": ctx,
			"env": env}, map[string]interface{}{
			"err": err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return err
}
