// Code generated by microgen 0.9.1. DO NOT EDIT.

package transport

import (
	items "git.perx.ru/perxis/perxis-go/pkg/items"
	schema "git.perx.ru/perxis/perxis-go/pkg/schema"
)

type (
	CreateRequest struct {
		Item *items.Item            `json:"item"`
		Opts []*items.CreateOptions `json:"opts"` // This field was defined with ellipsis (...).
	}
	CreateResponse struct {
		Created *items.Item `json:"created"`
	}

	IntrospectRequest struct {
		Item *items.Item                `json:"item"`
		Opts []*items.IntrospectOptions `json:"opts"` // This field was defined with ellipsis (...).
	}
	IntrospectResponse struct {
		Item             *items.Item    `json:"item"`
		Schema           *schema.Schema `json:"schema"`
		ValidationErrors []error        `json:"validation_errors"`
	}

	GetRequest struct {
		SpaceId      string              `json:"space_id"`
		EnvId        string              `json:"env_id"`
		CollectionId string              `json:"collection_id"`
		ItemId       string              `json:"item_id"`
		Options      []*items.GetOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	GetResponse struct {
		Item *items.Item `json:"item"`
	}

	FindRequest struct {
		SpaceId      string               `json:"space_id"`
		EnvId        string               `json:"env_id"`
		CollectionId string               `json:"collection_id"`
		Filter       *items.Filter        `json:"filter"`
		Options      []*items.FindOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	FindResponse struct {
		Items []*items.Item `json:"items"`
		Total int           `json:"total"`
	}

	UpdateRequest struct {
		Item    *items.Item            `json:"item"`
		Options []*items.UpdateOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	UpdateResponse struct{}

	DeleteRequest struct {
		Item    *items.Item            `json:"item"`
		Options []*items.DeleteOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	DeleteResponse struct{}

	UndeleteRequest struct {
		Item    *items.Item              `json:"item"`
		Options []*items.UndeleteOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	UndeleteResponse struct{}

	PublishRequest struct {
		Item    *items.Item             `json:"item"`
		Options []*items.PublishOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	PublishResponse struct{}

	UnpublishRequest struct {
		Item    *items.Item               `json:"item"`
		Options []*items.UnpublishOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	UnpublishResponse struct{}

	GetPublishedRequest struct {
		SpaceId      string                       `json:"space_id"`
		EnvId        string                       `json:"env_id"`
		CollectionId string                       `json:"collection_id"`
		ItemId       string                       `json:"item_id"`
		Options      []*items.GetPublishedOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	GetPublishedResponse struct {
		Item *items.Item `json:"item"`
	}

	FindPublishedRequest struct {
		SpaceId      string                        `json:"space_id"`
		EnvId        string                        `json:"env_id"`
		CollectionId string                        `json:"collection_id"`
		Filter       *items.Filter                 `json:"filter"`
		Options      []*items.FindPublishedOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	FindPublishedResponse struct {
		Items []*items.Item `json:"items"`
		Total int           `json:"total"`
	}

	GetRevisionRequest struct {
		SpaceId      string                      `json:"space_id"`
		EnvId        string                      `json:"env_id"`
		CollectionId string                      `json:"collection_id"`
		ItemId       string                      `json:"item_id"`
		RevisionId   string                      `json:"revision_id"`
		Options      []*items.GetRevisionOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	GetRevisionResponse struct {
		Item *items.Item `json:"item"`
	}

	ListRevisionsRequest struct {
		SpaceId      string                        `json:"space_id"`
		EnvId        string                        `json:"env_id"`
		CollectionId string                        `json:"collection_id"`
		ItemId       string                        `json:"item_id"`
		Options      []*items.ListRevisionsOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	ListRevisionsResponse struct {
		Items []*items.Item `json:"items"`
		Total int           `json:"total"`
	}

	ArchiveRequest struct {
		Item    *items.Item             `json:"item"`
		Options []*items.ArchiveOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	ArchiveResponse struct{}

	FindArchivedRequest struct {
		SpaceId      string                       `json:"space_id"`
		EnvId        string                       `json:"env_id"`
		CollectionId string                       `json:"collection_id"`
		Filter       *items.Filter                `json:"filter"`
		Options      []*items.FindArchivedOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	FindArchivedResponse struct {
		Items []*items.Item `json:"items"`
		Total int           `json:"total"`
	}

	UnarchiveRequest struct {
		Item    *items.Item               `json:"item"`
		Options []*items.UnarchiveOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	// Formal exchange type, please do not delete.
	UnarchiveResponse struct{}

	CheckoutRevisionRequest struct {
		SpaceId string `json:"space_id"`
		EnvId   string `json:"env_id"`
		CollId  string `json:"coll_id"`
		Id      string `json:"id"`
		RevId   string `json:"rev_id"`
	}
	CheckoutRevisionResponse struct {
		StoredRevId string `json:"stored_rev_id"`
	}

	AggregateRequest struct {
		SpaceId      string                    `json:"space_id"`
		EnvId        string                    `json:"env_id"`
		CollectionId string                    `json:"collection_id"`
		Filter       *items.Filter             `json:"filter"`
		Options      []*items.AggregateOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	AggregateResponse struct {
		Result map[string]interface{} `json:"result"`
	}

	AggregatePublishedRequest struct {
		SpaceId      string                             `json:"space_id"`
		EnvId        string                             `json:"env_id"`
		CollectionId string                             `json:"collection_id"`
		Filter       *items.Filter                      `json:"filter"`
		Options      []*items.AggregatePublishedOptions `json:"options"` // This field was defined with ellipsis (...).
	}
	AggregatePublishedResponse struct {
		Result map[string]interface{} `json:"result"`
	}
)
